OpenTTD Source: OrdersWindow Struct Reference

OpenTTD Source 15.0-RC2

Public Member Functions | Static Public Attributes | Private Types | Private Member Functions | Private Attributes
OrdersWindow Struct Reference

Order window code for all vehicles. More...

Inheritance diagram for OrdersWindow:

## Public Member Functions
| OrdersWindow (WindowDesc &desc, const Vehicle *v)
void | UpdateWidgetSize (WidgetID widget, Dimension &size, const Dimension &padding, Dimension &fill, Dimension &resize) override
| Update size and resize step of a widget in the window.
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid.
void | UpdateButtonState ()
void | OnPaint () override
| The window must be repainted.
void | DrawWidget (const Rect &r, WidgetID widget) const override
| Draw the contents of a nested widget.
std::string | GetWidgetString (WidgetID widget, StringID stringid) const override
| Get the raw string for a widget.
void | OnClick (Point pt, WidgetID widget, int click_count) override
| A click with the left mouse button has been made on the window.
void | OnQueryTextFinished (std::optional< std::string > str) override
| The query window opened from this window has closed.
void | OnDropdownSelect (WidgetID widget, int index, int) override
| A dropdown option associated to this window has been selected.
void | OnDragDrop (Point pt, WidgetID widget) override
| A dragged 'object' has been released.
EventState | OnHotkey (int hotkey) override
| A hotkey has been pressed.
void | OnPlaceObject (Point pt, TileIndex tile) override
| The user clicked some place on the map when a tile highlight mode has been set.
bool | OnVehicleSelect (const Vehicle *v) override
bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end) override
| Clones an order list from a vehicle list.
void | OnPlaceObjectAbort () override
| The user cancelled a tile highlight mode that has been set.
void | OnMouseDrag (Point pt, WidgetID widget) override
| An 'object' is being dragged at the provided position, highlight the target if possible.
void | OnResize () override
| Called after the window got resized.
Public Member Functions inherited from Window
| Window (WindowDesc &desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree.
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox.
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (size_t from, size_t to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled.
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered.
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised.
void | RaiseWidgetWhenLowered (WidgetID widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered.
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (WidgetID wid, std::string_view str, bool marked, std::optional< size_t > caret, std::optional< size_t > insert_location, std::optional< size_t > replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets.
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets.
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered.
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
Window * | FindChildWindow (WindowClass wc=WC_INVALID) const
| Find the Window whose parent pointer points to this window.
Window * | FindChildWindowById (WindowClass wc, WindowNumber number) const
| Find the Window whose parent pointer points to this window.
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner.
void | CloseChildWindowById (WindowClass wc, WindowNumber number) const
| Close all children a window might have in a head-recursive manner.
virtual void | Close (int data=0)
| Hide the window and all its child windows, and mark them for a later deletion.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnFocus ()
| The window has gained focus.
virtual void | OnFocusLost (bool closing)
| The window has lost focus.
virtual EventState | OnKeyPress (char32_t key, uint16_t keycode)
| A key has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, WidgetID widget)
| A click with the right mouse button has been made on the window.
virtual void | OnHover (Point pt, WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it.
virtual bool | OnTooltip (Point pt, WidgetID widget, TooltipCloseCondition close_cond)
| Event to display a custom tooltip.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnScrollbarScroll (WidgetID widget)
| Notify window that a scrollbar position has been updated.
virtual void | OnMouseOver (Point pt, WidgetID widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel, WidgetID widget)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, int click_result, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnEditboxChanged (WidgetID widget)
| The text in an editbox has been edited.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.

## Static Public Attributes
static HotkeyList | hotkeys

## Private Types
enum | OrderPlaceObjectState : uint8_t { OPOS_NONE , OPOS_GOTO , OPOS_CONDITIONAL , OPOS_SHARE , OPOS_END }
| Under what reason are we using the PlaceObject functionality? More...
enum | DisplayPane : uint8_t { DP_GROUNDVEHICLE_ROW_NORMAL = 0 , DP_GROUNDVEHICLE_ROW_CONDITIONAL = 1 , DP_LEFT_LOAD = 0 , DP_LEFT_REFIT = 1 , DP_MIDDLE_UNLOAD = 0 , DP_MIDDLE_SERVICE = 1 , DP_RIGHT_EMPTY = 0 , DP_RIGHT_REFIT = 1 , DP_ROW_LOAD = 0 , DP_ROW_DEPOT = 1 , DP_ROW_CONDITIONAL = 2 , DP_BOTTOM_MIDDLE_DELETE = 0 , DP_BOTTOM_MIDDLE_STOP_SHARING = 1 }
| Displayed planes of the NWID_SELECTION widgets. More...

## Private Member Functions
VehicleOrderID | OrderGetSel () const
| Return the memorised selected order.
VehicleOrderID | GetOrderFromPt (int y)
| Calculate the selected order.
void | OrderClick_Goto (OrderPlaceObjectState type)
| Handle the click on the goto button.
void | OrderClick_FullLoad (OrderLoadType load_type, bool toggle=false)
| Handle the click on the full load button.
void | OrderClick_Service (std::optional< OrderDepotAction > i)
| Handle the click on the service.
void | OrderClick_NearestDepot ()
| Handle the click on the service in nearest depot button.
void | OrderClick_Unload (OrderUnloadType unload_type, bool toggle=false)
| Handle the click on the unload button.
void | OrderClick_Nonstop (std::optional< OrderNonStopFlags > non_stop)
| Handle the click on the nonstop button.
void | OrderClick_Skip ()
| Handle the click on the skip button.
void | OrderClick_Delete ()
| Handle the click on the delete button.
void | OrderClick_StopSharing ()
| Handle the click on the 'stop sharing' button.
void | OrderClick_Refit (int i, bool auto_refit)
| Handle the click on the refit button.
void | UpdateAutoRefitState ()
| Cache auto-refittability of the vehicle chain.

## Private Attributes
int | selected_order = -1
VehicleOrderID | order_over = INVALID_VEH_ORDER_ID
| Order over which another order is dragged, `INVALID_VEH_ORDER_ID` if none.
OrderPlaceObjectState | goto_type = OPOS_NONE
const Vehicle * | vehicle = nullptr
| Vehicle owning the orders being displayed and manipulated.
Scrollbar * | vscroll = nullptr
bool | can_do_refit = false
| Vehicle chain can be refitted in depot.
bool | can_do_autorefit = false
| Vehicle chain can be auto-refitted.

## Additional Inherited Members
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
static void | DeleteClosedWindows ()
| Delete all closed windows.
Data Fields inherited from Window
WindowDesc & | window_desc
| Window description.
WindowFlags | flags {}
| Window flags.
WindowClass | window_class {}
| Window class.
WindowNumber | window_number = 0
| Window number within the window class.
int | scale = 0
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer = 0
| Timer value of the WindowFlag::Timeout for flags.
uint8_t | white_border_timer = 0
| Timer value of the WindowFlag::WhiteBorder for flags.
int | left = 0
| x position of left edge of the window
int | top = 0
| y position of top edge of the window
int | width = 0
| width of the window (number of pixels to the right in x direction)
int | height = 0
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize {}
| Resize information.
Owner | owner = INVALID_OWNER
| The owner of the content shown in this window. Company colour is acquired from this variable.
std::unique_ptr< ViewportData > | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus = nullptr
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings {}
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root {}
| Root of the nested tree.
WidgetLookup | widget_lookup {}
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select = nullptr
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size {}
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget = INVALID_WIDGET
| ID of current mouse capture widget (e.g. dragged scrollbar). `INVALID_WIDGET` if no widget has mouse capture.
Window * | parent = nullptr
| Parent window.
WindowList::iterator | z_position {}
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height, bool allow_resize)
| Resize window towards the default size.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data {}
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize = false
| Set if window has been resized.

## Detailed Description

Order window code for all vehicles.

At the bottom of the window two button rows are located for changing the orders of the vehicle.

# Top row

The top-row is for manipulating an individual order. What row is displayed depends on the type of vehicle, and whether or not you are the owner of the vehicle.

The top-row buttons of one of your trains or road vehicles is one of the following three cases:

    * +-----------------+-----------------+-----------------+-----------------+
    * |    NON-STOP     |    FULL_LOAD    |     UNLOAD      |      REFIT      | (normal)
    * +-----------------+-----+-----------+-----------+-----+-----------------+
    * |       COND_VAR        |    COND_COMPARATOR    |      COND_VALUE       | (for conditional orders)
    * +-----------------+-----+-----------+-----------+-----+-----------------+
    * |    NON-STOP     |      REFIT      |     SERVICE     |     (empty)     | (for depot orders)
    * +-----------------+-----------------+-----------------+-----------------+
    *

Airplanes and ships have one of the following three top-row button rows:

    * +-----------------+-----------------+-----------------+
    * |    FULL_LOAD    |     UNLOAD      |      REFIT      | (normal)
    * +-----------------+-----------------+-----------------+
    * |    COND_VAR     | COND_COMPARATOR |   COND_VALUE    | (for conditional orders)
    * +-----------------+--------+--------+-----------------+
    * |            REFIT         |          SERVICE         | (for depot order)
    * +--------------------------+--------------------------+
    *

# Bottom row

The second row (the bottom row) is for manipulating the list of orders:

    * +-----------------+-----------------+-----------------+
    * |      SKIP       |     DELETE      |      GOTO       |
    * +-----------------+-----------------+-----------------+
    *

For vehicles of other companies, both button rows are not displayed.

Definition at line 520 of file order_gui.cpp.

## Member Enumeration Documentation

## ◆ DisplayPane

enum OrdersWindow::DisplayPane : uint8_t
| private

Displayed planes of the NWID_SELECTION widgets.

Enumerator
DP_GROUNDVEHICLE_ROW_NORMAL | Display the row for normal/depot orders in the top row of the train/rv order window.
DP_GROUNDVEHICLE_ROW_CONDITIONAL | Display the row for conditional orders in the top row of the train/rv order window.
DP_LEFT_LOAD | Display 'load' in the left button of the top row of the train/rv order window.
DP_LEFT_REFIT | Display 'refit' in the left button of the top row of the train/rv order window.
DP_MIDDLE_UNLOAD | Display 'unload' in the middle button of the top row of the train/rv order window.
DP_MIDDLE_SERVICE | Display 'service' in the middle button of the top row of the train/rv order window.
DP_RIGHT_EMPTY | Display an empty panel in the right button of the top row of the train/rv order window.
DP_RIGHT_REFIT | Display 'refit' in the right button of the top row of the train/rv order window.
DP_ROW_LOAD | Display 'load' / 'unload' / 'refit' buttons in the top row of the ship/airplane order window.
DP_ROW_DEPOT | Display 'refit' / 'service' buttons in the top row of the ship/airplane order window.
DP_ROW_CONDITIONAL | Display the conditional order buttons in the top row of the ship/airplane order window.
DP_BOTTOM_MIDDLE_DELETE | Display 'delete' in the middle button of the bottom row of the vehicle order window.
DP_BOTTOM_MIDDLE_STOP_SHARING | Display 'stop sharing' in the middle button of the bottom row of the vehicle order window.

Definition at line 532 of file order_gui.cpp.

## ◆ OrderPlaceObjectState

enum OrdersWindow::OrderPlaceObjectState : uint8_t
| private

Under what reason are we using the PlaceObject functionality?

Definition at line 523 of file order_gui.cpp.

## Constructor & Destructor Documentation

## ◆ OrdersWindow()

OrdersWindow::OrdersWindow | ( | WindowDesc & | desc,
|  | const Vehicle * | v
| ) |  |
| inline

Definition at line 792 of file order_gui.cpp.

## Member Function Documentation

## ◆ DrawWidget()

void OrdersWindow::DrawWidget | ( | const Rect & | r,
|  | WidgetID | widget
| ) |  | const
| inlineoverridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1091 of file order_gui.cpp.

References _current_text_dir, DrawOrderString(), DrawString(), GetColourGradient(), Vehicle::GetNumOrders(), Vehicle::GetOrder(), GetParamMaxValue(), Scrollbar::GetPosition(), GetSpriteSize(), GetString(), GetStringBoundingBox(), GfxFillRect(), INVALID_VEH_ORDER_ID, Vehicle::IsOrderListShared(), Scrollbar::IsVisible(), WidgetDimensions::scaled, Rect::Shrink(), TD_RTL, Window::top, WID_O_ORDER_LIST, and Window::width.

## ◆ GetOrderFromPt()

VehicleOrderID OrdersWindow::GetOrderFromPt | ( | int | y | ) |
| inlineprivate

Calculate the selected order.

The calculation is based on the relative (to the window) y click position and the position of the scrollbar.

Parameters

  y | Y-value of the click relative to the window origin

Returns
  The selected order if the order is valid, else return `INVALID_VEH_ORDER_ID`.

Definition at line 586 of file order_gui.cpp.

References Vehicle::GetNumOrders(), Scrollbar::GetScrolledRowFromWidget(), INVALID_VEH_ORDER_ID, IsInsideBS(), WidgetDimensions::scaled, vehicle, and WID_O_ORDER_LIST.

Referenced by OnClick(), OnDragDrop(), and OnMouseDrag().

## ◆ GetWidgetString()

std::string OrdersWindow::GetWidgetString | ( | WidgetID | widget,
|  | StringID | stringid
| ) |  | const
| inlineoverridevirtual

Get the raw string for a widget.

Calls to this function are also made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.
  stringid | StringID assigned to widget.

Returns
  raw string to display.

Reimplemented from Window.

Definition at line 1148 of file order_gui.cpp.

References ConvertSpeedToDisplaySpeed(), Order::GetConditionValue(), Order::GetConditionVariable(), Order::GetDepotActionType(), Order::GetDepotOrderType(), Vehicle::GetOrder(), GetString(), Window::GetWidgetString(), Halt, Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem< Tpool >::index, Order::IsType(), MaxSpeed, OrderGetSel(), Service, BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Test(), BaseVehicle::type, Unbunch, WID_O_CAPTION, WID_O_COND_VALUE, and WID_O_DEPOT_ACTION.

## ◆ OnClick()

void OrdersWindow::OnClick | ( | Point | pt,
|  | WidgetID | widget,
|  | int | click_count
| ) |  |
| inlineoverridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1184 of file order_gui.cpp.

References _ctrl_pressed, _local_company, _order_conditional_variable, BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::base(), Window::CloseChildWindows(), ConvertSpeedToDisplaySpeed(), CS_NUMERAL, FullLoadAny, Order::GetConditionComparator(), Order::GetConditionValue(), Order::GetConditionVariable(), Order::GetLoadType(), Order::GetLocation(), Order::GetNonStopType(), Vehicle::GetNumOrders(), Vehicle::GetOrder(), GetOrderFromPt(), Order::GetStopLocation(), GetString(), Order::GetUnloadType(), HT_DRAG, INVALID_TILE, INVALID_VEH_ORDER_ID, Order::IsType(), Order::MakeConditional(), MaxSpeed, MOF_STOP_LOCATION, OrderClick_Delete(), OrderClick_FullLoad(), OrderClick_Goto(), OrderClick_Nonstop(), OrderClick_Refit(), OrderClick_Skip(), OrderClick_StopSharing(), OrderClick_Unload(), OrderGetSel(), Vehicle::owner, CursorVars::pos, RequiresService, ResetObjectToPlace(), ScrollMainWindowToTile(), SetObjectToPlaceWnd(), ShowDropDownList(), ShowDropDownMenu(), ShowQueryString(), ShowTimetableWindow(), SPR_CURSOR_MOUSE, Vehicle::tile, to_underlying(), BaseVehicle::type, Unload, VEH_AIRCRAFT, VEH_TRAIN, vehicle, WID_O_COND_COMPARATOR, WID_O_COND_VALUE, WID_O_COND_VARIABLE, WID_O_DELETE, WID_O_DEPOT_ACTION, WID_O_FULL_LOAD, WID_O_GOTO, WID_O_NON_STOP, WID_O_ORDER_LIST, WID_O_REFIT, WID_O_REFIT_DROPDOWN, WID_O_SHARED_ORDER_LIST, WID_O_SKIP, WID_O_STOP_SHARING, WID_O_TIMETABLE_VIEW, WID_O_UNLOAD, and Coord2D< T >::y.

## ◆ OnDragDrop()

void OrdersWindow::OnDragDrop | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inlineoverridevirtual

A dragged 'object' has been released.

Parameters

  pt | the point inside the window where the release took place.
  widget | the widget where the release took place.

Reimplemented from Window.

Definition at line 1411 of file order_gui.cpp.

References Vehicle::GetNumOrders(), GetOrderFromPt(), INVALID_VEH_ORDER_ID, OrderClick_Delete(), OrderClick_StopSharing(), OrderGetSel(), ResetObjectToPlace(), Window::SetWidgetDirty(), WID_O_DELETE, WID_O_ORDER_LIST, WID_O_STOP_SHARING, and Coord2D< T >::y.

## ◆ OnDropdownSelect()

void OrdersWindow::OnDropdownSelect | ( | WidgetID | widget,
|  | int | index,
|  | int | click_result
| ) |  |
| inlineoverridevirtual

A dropdown option associated to this window has been selected.

Parameters

  widget | the widget (button) that the dropdown is associated with.
  index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 1368 of file order_gui.cpp.

References MOF_COND_COMPARATOR, MOF_COND_VARIABLE, OrderClick_FullLoad(), OrderClick_Goto(), OrderClick_NearestDepot(), OrderClick_Nonstop(), OrderClick_Refit(), OrderClick_Service(), OrderClick_Unload(), Vehicle::tile, WID_O_COND_COMPARATOR, WID_O_COND_VARIABLE, WID_O_DEPOT_ACTION, WID_O_FULL_LOAD, WID_O_GOTO, WID_O_NON_STOP, WID_O_REFIT_DROPDOWN, and WID_O_UNLOAD.

## ◆ OnHotkey()

EventState OrdersWindow::OnHotkey | ( | int | hotkey | ) |
| inlineoverridevirtual

A hotkey has been pressed.

Parameters

  hotkey | Hotkey index, by default a widget index of a button or editbox.

Returns
  ES_HANDLED if the key press has been handled, and the hotkey is not unavailable for some reason.

Reimplemented from Window.

Definition at line 1444 of file order_gui.cpp.

References _local_company, ES_HANDLED, ES_NOT_HANDLED, FullLoadAny, NoLoad, NoUnload, OrderClick_Delete(), OrderClick_FullLoad(), OrderClick_Goto(), OrderClick_NearestDepot(), OrderClick_Nonstop(), OrderClick_Service(), OrderClick_Skip(), OrderClick_Unload(), Vehicle::owner, Transfer, and Unload.

## ◆ OnInvalidateData()

void OrdersWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 850 of file order_gui.cpp.

References Window::CloseChildWindows(), GB(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_vehicle_pool >::Get(), Vehicle::GetNumOrders(), INVALID_VEH_ORDER_ID, Scrollbar::IsVisible(), Scrollbar::ScrollTowards(), Scrollbar::SetCount(), UpdateAutoRefitState(), VIWD_AUTOREPLACE, VIWD_CONSIST_CHANGED, VIWD_MODIFY_ORDERS, VIWD_REMOVE_ALL_ORDERS, and Window::window_number.

## ◆ OnMouseDrag()

void OrdersWindow::OnMouseDrag | ( | Point | pt,
|  | WidgetID | widget
| ) |  |
| inlineoverridevirtual

An 'object' is being dragged at the provided position, highlight the target if possible.

Parameters

  pt | The point inside the window that the mouse hovers over.
  widget | The widget the mouse hovers over.

Reimplemented from Window.

Definition at line 1542 of file order_gui.cpp.

References Vehicle::GetNumOrders(), GetOrderFromPt(), INVALID_VEH_ORDER_ID, OrderGetSel(), Window::SetWidgetDirty(), WID_O_ORDER_LIST, and Coord2D< T >::y.

## ◆ OnPaint()

void OrdersWindow::OnPaint | ( |  | ) |
| inlineoverridevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1081 of file order_gui.cpp.

References _local_company, Window::DrawWidgets(), Vehicle::owner, Window::SetWidgetLoweredState(), and WID_O_GOTO.

## ◆ OnPlaceObject()

void OrdersWindow::OnPlaceObject | ( | Point | pt,
|  | TileIndex | tile
| ) |  |
| inlineoverridevirtual

The user clicked some place on the map when a tile highlight mode has been set.

Parameters

  pt | the exact point on the map that has been clicked.
  tile | the tile on the map that has been clicked.

Reimplemented from Window.

Definition at line 1465 of file order_gui.cpp.

References _settings_client, GetOrderCmdFromTile(), ClientSettings::gui, Order::IsType(), GUISettings::quick_goto, ResetObjectToPlace(), and Vehicle::tile.

## ◆ OnPlaceObjectAbort()

void OrdersWindow::OnPlaceObjectAbort | ( |  | ) |
| inlineoverridevirtual

The user cancelled a tile highlight mode that has been set.

Reimplemented from Window.

Definition at line 1530 of file order_gui.cpp.

References INVALID_VEH_ORDER_ID, Window::SetWidgetDirty(), WID_O_GOTO, and WID_O_ORDER_LIST.

## ◆ OnQueryTextFinished()

void OrdersWindow::OnQueryTextFinished | ( | std::optional< std::string > | str | ) |
| inlineoverridevirtual

The query window opened from this window has closed.

Parameters

  str | the new value of the string, `std::nullopt` if the window was cancelled or an empty string when the default button was pressed, i.e. `str->empty()`.

Reimplemented from Window.

Definition at line 1344 of file order_gui.cpp.

References Clamp(), ConvertDisplaySpeedToSpeed(), Order::GetConditionVariable(), Vehicle::GetOrder(), LoadPercentage, MaxSpeed, MOF_COND_VALUE, OrderGetSel(), ParseInteger(), Reliability, Vehicle::tile, and BaseVehicle::type.

## ◆ OnResize()

void OrdersWindow::OnResize | ( |  | ) |
| inlineoverridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 1562 of file order_gui.cpp.

References WidgetDimensions::scaled, Scrollbar::SetCapacityFromWidget(), and WID_O_ORDER_LIST.

## ◆ OnVehicleSelect() [1/2]

bool OrdersWindow::OnVehicleSelect | ( | const Vehicle * | v | ) |
| inlineoverride

Definition at line 1478 of file order_gui.cpp.

## ◆ OnVehicleSelect() [2/2]

bool OrdersWindow::OnVehicleSelect | ( | VehicleList::const_iterator | begin,
|  | VehicleList::const_iterator | end
| ) |  |
| inlineoverridevirtual

Clones an order list from a vehicle list.

If this doesn't make sense (because not all vehicles in the list have the same orders), then it displays an error.

Returns
  This always returns true, which indicates that the contextual action handled the mouse click. Note that it's correct behaviour to always handle the click even though an error is displayed, because users aren't going to expect the default action to be performed just because they overlooked that cloning doesn't make sense.

Reimplemented from Window.

Definition at line 1502 of file order_gui.cpp.

References _ctrl_pressed, AllEqual(), Vehicle::FirstShared(), GetEncodedString(), Vehicle::GetNumOrders(), ShowErrorMessage(), VehiclesHaveSameOrderList(), and WL_INFO.

## ◆ OrderClick_Delete()

void OrdersWindow::OrderClick_Delete | ( |  | ) |
| inlineprivate

Handle the click on the delete button.

Definition at line 725 of file order_gui.cpp.

References _networking, Vehicle::GetNumOrders(), and Vehicle::tile.

Referenced by OnClick(), OnDragDrop(), OnHotkey(), and OrderClick_StopSharing().

## ◆ OrderClick_FullLoad()

void OrdersWindow::OrderClick_FullLoad | ( | OrderLoadType | load_type,
|  | bool | toggle = `false`
| ) |  |
| inlineprivate

Handle the click on the full load button.

Parameters

  load_type | Load flag to apply. If matches existing load type, toggles to default of 'load if possible'.
  toggle | If we toggle or not (used for hotkey behavior)

Definition at line 617 of file order_gui.cpp.

References Order::GetLoadType(), Vehicle::GetOrder(), LoadIfPossible, MOF_LOAD, OrderGetSel(), Vehicle::tile, and to_underlying().

Referenced by OnClick(), OnDropdownSelect(), and OnHotkey().

## ◆ OrderClick_Goto()

void OrdersWindow::OrderClick_Goto | ( | OrderPlaceObjectState | type | ) |
| inlineprivate

Handle the click on the goto button.

Definition at line 598 of file order_gui.cpp.

References ANIMCURSOR_PICKSTATION, HT_NONE, HT_RECT, HT_VEHICLE, SetObjectToPlaceWnd(), Window::SetWidgetDirty(), and WID_O_GOTO.

Referenced by OnClick(), OnDropdownSelect(), and OnHotkey().

## ◆ OrderClick_NearestDepot()

void OrdersWindow::OrderClick_NearestDepot | ( |  | ) |
| inlineprivate

Handle the click on the service in nearest depot button.

Definition at line 650 of file order_gui.cpp.

References _settings_client, ClientSettings::gui, Order::MakeGoToDepot(), NearestDepot, GUISettings::new_nonstop, NoIntermediate, PartOfOrders, Order::SetDepotActionType(), and Vehicle::tile.

Referenced by OnDropdownSelect(), and OnHotkey().

## ◆ OrderClick_Nonstop()

void OrdersWindow::OrderClick_Nonstop | ( | std::optional< OrderNonStopFlags > | non_stop | ) |
| inlineprivate

Handle the click on the nonstop button.

Parameters

  non_stop | what non-stop type to use; std::nullopt to use the 'next' one.

Definition at line 690 of file order_gui.cpp.

References BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Flip(), Order::GetNonStopType(), Vehicle::GetOrder(), Vehicle::IsGroundVehicle(), MOF_NON_STOP, NoIntermediate, OrderGetSel(), Window::SetWidgetDirty(), Vehicle::tile, and WID_O_NON_STOP.

Referenced by OnClick(), OnDropdownSelect(), and OnHotkey().

## ◆ OrderClick_Refit()

void OrdersWindow::OrderClick_Refit | ( | int | i,
|  | bool | auto_refit
| ) |  |
| inlineprivate

Handle the click on the refit button.

If ctrl is pressed, cancel refitting, else show the refit window.

Parameters

  i | Selected refit command.
  auto_refit | Select refit for auto-refitting.

Definition at line 766 of file order_gui.cpp.

References _ctrl_pressed, CARGO_AUTO_REFIT, CARGO_NO_REFIT, OrderGetSel(), ShowVehicleRefitWindow(), and Vehicle::tile.

Referenced by OnClick(), and OnDropdownSelect().

## ◆ OrderClick_Service()

void OrdersWindow::OrderClick_Service | ( | std::optional< OrderDepotAction > | i | ) |
| inlineprivate

Handle the click on the service.

Definition at line 635 of file order_gui.cpp.

References AlwaysGo, Order::GetDepotOrderType(), Vehicle::GetOrder(), MOF_DEPOT_ACTION, OrderGetSel(), Service, BaseBitSet< Timpl, Tvalue_type, Tstorage, Tmask >::Test(), Vehicle::tile, and to_underlying().

Referenced by OnDropdownSelect(), and OnHotkey().

## ◆ OrderClick_Skip()

void OrdersWindow::OrderClick_Skip | ( |  | ) |
| inlineprivate

Handle the click on the skip button.

If ctrl is pressed, skip to selected order, else skip to current order + 1

Definition at line 712 of file order_gui.cpp.

References _ctrl_pressed, BaseConsist::cur_implicit_order_index, Vehicle::GetNumOrders(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem< Tpool >::index, OrderGetSel(), and Vehicle::tile.

Referenced by OnClick(), and OnHotkey().

## ◆ OrderClick_StopSharing()

void OrdersWindow::OrderClick_StopSharing | ( |  | ) |
| inlineprivate

Handle the click on the 'stop sharing' button.

If 'End of Shared Orders' isn't selected, do nothing. If Ctrl is pressed, call OrderClick_Delete and exit. To stop sharing this vehicle order list, we copy the orders of a vehicle that share this order list. That way we exit the group of shared vehicles while keeping the same order list.

Definition at line 742 of file order_gui.cpp.

References _ctrl_pressed, Vehicle::FirstShared(), Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem< Tpool >::index, Vehicle::IsOrderListShared(), Vehicle::NextShared(), OrderClick_Delete(), Vehicle::PreviousShared(), Vehicle::tile, and vehicle.

Referenced by OnClick(), and OnDragDrop().

## ◆ OrderClick_Unload()

void OrdersWindow::OrderClick_Unload | ( | OrderUnloadType | unload_type,
|  | bool | toggle = `false`
| ) |  |
| inlineprivate

Handle the click on the unload button.

Parameters

  unload_type | Unload flag to apply. If matches existing unload type, toggles to default of 'unload if possible'.
  toggle | If we toggle or not (used for hotkey behavior)

Definition at line 665 of file order_gui.cpp.

References Vehicle::GetOrder(), Order::GetUnloadType(), MOF_LOAD, MOF_UNLOAD, NoLoad, OrderGetSel(), Window::SetWidgetDirty(), Vehicle::tile, to_underlying(), Transfer, Unload, UnloadIfPossible, and WID_O_FULL_LOAD.

Referenced by OnClick(), OnDropdownSelect(), and OnHotkey().

## ◆ OrderGetSel()

VehicleOrderID OrdersWindow::OrderGetSel | ( |  | ) | const
| inlineprivate

Return the memorised selected order.

Returns
  the memorised order if it is a valid one else return the number of orders

Definition at line 572 of file order_gui.cpp.

References Vehicle::GetNumOrders(), and vehicle.

Referenced by GetWidgetString(), OnClick(), OnDragDrop(), OnMouseDrag(), OnQueryTextFinished(), OrderClick_FullLoad(), OrderClick_Nonstop(), OrderClick_Refit(), OrderClick_Service(), OrderClick_Skip(), and OrderClick_Unload().

## ◆ UpdateAutoRefitState()

void OrdersWindow::UpdateAutoRefitState | ( |  | ) |
| inlineprivate

Cache auto-refittability of the vehicle chain.

Definition at line 781 of file order_gui.cpp.

References AutoRefit, Pool< Titem, Tindex, Tgrowth_step, Tpool_type, Tcache >::PoolItem<&_engine_pool >::Get(), IsEngineRefittable(), and Vehicle::IsGroundVehicle().

Referenced by OnInvalidateData().

## ◆ UpdateButtonState()

void OrdersWindow::UpdateButtonState | ( |  | ) |
| inline

Definition at line 920 of file order_gui.cpp.

## ◆ UpdateWidgetSize()

void OrdersWindow::UpdateWidgetSize | ( | WidgetID | widget,
|  | Dimension & | size,
|  | const Dimension & | padding,
|  | Dimension & | fill,
|  | Dimension & | resize
| ) |  |
| inlineoverridevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  | widget | Widget number.
  [in,out] | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  [in,out] | fill | Fill step of the widget.
  [in,out] | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 816 of file order_gui.cpp.

References _order_conditional_variable, FS_NORMAL, GetCharacterHeight(), GetStringBoundingBox(), GetStringListBoundingBox(), maxdim(), Window::resize, to_underlying(), WID_O_COND_COMPARATOR, WID_O_COND_VARIABLE, and WID_O_ORDER_LIST.

## Field Documentation

## ◆ can_do_autorefit

bool OrdersWindow::can_do_autorefit = false
| private

Vehicle chain can be auto-refitted.

Definition at line 565 of file order_gui.cpp.

## ◆ can_do_refit

bool OrdersWindow::can_do_refit = false
| private

Vehicle chain can be refitted in depot.

Definition at line 564 of file order_gui.cpp.

## ◆ goto_type

OrderPlaceObjectState OrdersWindow::goto_type = OPOS_NONE
| private

Definition at line 561 of file order_gui.cpp.

## ◆ hotkeys

HotkeyList OrdersWindow::hotkeys
| inlinestatic

Initial value:
{"order", {
Hotkey('D', "skip", OHK_SKIP),
Hotkey('F', "delete", OHK_DELETE),
Hotkey('G', "goto", OHK_GOTO),
Hotkey('H', "nonstop", OHK_NONSTOP),
Hotkey('J', "fullload", OHK_FULLLOAD),
Hotkey('K', "unload", OHK_UNLOAD),
Hotkey(0, "nearest_depot", OHK_NEAREST_DEPOT),
Hotkey(0, "always_service", OHK_ALWAYS_SERVICE),
Hotkey(0, "transfer", OHK_TRANSFER),
Hotkey(0, "no_unload", OHK_NO_UNLOAD),
Hotkey(0, "no_load", OHK_NO_LOAD),
}}
Hotkey
All data for a single hotkey.
Definition hotkeys.h:21

Definition at line 1568 of file order_gui.cpp.

## ◆ order_over

VehicleOrderID OrdersWindow::order_over = INVALID_VEH_ORDER_ID
| private

Order over which another order is dragged, `INVALID_VEH_ORDER_ID` if none.

Definition at line 560 of file order_gui.cpp.

## ◆ selected_order

int OrdersWindow::selected_order = -1
| private

Definition at line 559 of file order_gui.cpp.

## ◆ vehicle

const Vehicle* OrdersWindow::vehicle = nullptr
| private

Vehicle owning the orders being displayed and manipulated.

Definition at line 562 of file order_gui.cpp.

Referenced by GetOrderFromPt(), OnClick(), OrderClick_StopSharing(), and OrderGetSel().

## ◆ vscroll

Scrollbar* OrdersWindow::vscroll = nullptr
| private

Definition at line 563 of file order_gui.cpp.

The documentation for this struct was generated from the following file:

- src/order_gui.cpp